﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace ExpandableXamDataGrid
{
    public abstract class Model : INotifyPropertyChanged
    {
        public static readonly Model0 Root;

        static Model()
        {
            Root = new Model0
            {
                Name = "Root",
                Children = new ObservableCollection<Model1>
                {
                    new Model1
                    {
                        Name = "R.C[0]",
                        Child = new Model1 { Name = "R.C[0].Child" }
#if children
                        Children = new ObservableCollection<Model1>
                        {
                            new Model1 { Name = "R.C[0].C[0]" },
                            new Model1 { Name = "R.C[0].C[1]" }
                        }
#endif
                    },
                    new Model1
                    {
                        Name = "R.C[1]",
                        Child = new Model1 { Name = "R.C[0].Child" }
#if children
                        Children = new ObservableCollection<Model1>
                        {
                            new Model1 { Name = "R.C[1].C[0]" },
                            new Model1 { Name = "R.C[1].C[1]" }
                        }
#endif
                    }
                }
            };
        }

        public event PropertyChangedEventHandler PropertyChanged = delegate { };
        protected void OnPropertyChanged(string name)
        {
            PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }

    public class Model1 : Model
    {
        private string name;
        public string Name
        {
            get { return name; }
            set { name = value; OnPropertyChanged("Name"); }
        }

        private Model1 child;
        public Model1 Child
        {
            get { return child; }
            set { child = value; OnPropertyChanged("Child"); }
        }

#if children
        public ObservableCollection<Model1> Children { get; set; }
#endif

        public Model1()
        {
#if children
            Children = new ObservableCollection<Model1>();
#endif
        }

        public override string ToString()
        {
            return "Model1[" + Name + "]";
        }
    }

    public class Model0 : Model
    {
        private string name;
        public string Name
        {
            get { return name; }
            set { name = value; OnPropertyChanged("Name"); }
        }

        private ObservableCollection<Model1> children;
        public ObservableCollection<Model1> Children
        {
            get { return children; }
            set { children = value; OnPropertyChanged("Children"); }
        }

        public Model0()
        {
            Children = new ObservableCollection<Model1>();
        }
    }
}
